
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
            xmlns:saxon="http://icl.com/saxon"
	        version="1.0">

<!--===============================================-->
<!--  lambda.xsl                                   -->
<!--  The interpreter of the Lambda-calculation    -->
<!--===============================================-->

<!--===========The syntax is: =====================-->
<!-- < Expr > ::=  < Variable >                    -->
<!--           |   ('\\' < Variable > '.' < Expr >)-->
<!--           |   ( < Expr > < Expr > )           -->
<!--===============================================-->

<!--====================================================-->
<!-- Syntax for XSLT on example                        -->
<!-- let mult  = (\n. (\m. (n (add m)) zero))           -->
<!--                                                    -->
<!-- <expr type="lambda" name="n">                      -->
<!--     <expr type="lambda" name="m">                  -->
<!--         <expr>                                     -->
<!--             <expr>                                 -->
<!--                 <expr type="var" name="n"/>        -->
<!--                 <expr>                             -->
<!--                     <expr type="var" name="add"/>  -->
<!--                     <expr type="var" name="m"/>    -->
<!--                 </expr>                            -->
<!--             </expr>                                -->
<!--             <expr type="var" name="zero"/>         -->
<!--         </expr>                                    -->
<!--     </expr>                                        -->
<!-- </expr>                                            -->
<!--====================================================-->

<xsl:template match="lambda">

<lambda>
    <xsl:call-template name="newline"/>
    <xsl:copy-of select="text"/>
    <xsl:call-template name="newline"/>
    <result>
        <xsl:call-template name="newline"/>

        <xsl:call-template name="prout">
        <xsl:with-param name="pr">
            <xsl:call-template name="CheckGo">
            <xsl:with-param name="parm">
                <check ccc="yes"/>
                <expr>
                    <xsl:call-template name="prelude">
                    <xsl:with-param name="eexpr">
                        <xsl:copy-of select="expr"/>
                    </xsl:with-param>
                    </xsl:call-template>
                </expr>
            </xsl:with-param>
            </xsl:call-template>
        </xsl:with-param>
        </xsl:call-template>

        <xsl:call-template name="newline"/>
    </result>
</lambda>

</xsl:template>

<!--============================================-->
<!--    Check of the end of calculation         -->

<xsl:template name="CheckGo"> 
<xsl:param name="parm"/>
<xsl:choose>
    <xsl:when test="saxon:nodeSet($parm)/check/@ccc='yes'">
        <xsl:call-template name="CheckGo">
        <xsl:with-param name="parm">
            <xsl:call-template name="apply">
            <xsl:with-param name="parm">
                <xsl:copy-of select="saxon:nodeSet($parm)/expr"/>
            </xsl:with-param>
            </xsl:call-template>
        </xsl:with-param>
        </xsl:call-template>
    </xsl:when>
    
    <xsl:otherwise>
        <xsl:copy-of select="saxon:nodeSet($parm)/expr"/>
    </xsl:otherwise>
</xsl:choose>
</xsl:template>

<!--============================================-->
<!--    Basis cycle of processing               -->

<xsl:template name="apply"> 
<xsl:param name="parm"/>

<xsl:choose>

<xsl:when test="saxon:nodeSet($parm)/expr/@type='var'">
       <check ccc="no"/>
       <xsl:copy-of select="saxon:nodeSet($parm)/expr"/>
</xsl:when>

<xsl:when test="saxon:nodeSet($parm)/expr/@type='lambda'">
    <xsl:call-template name="CheckL">
    <xsl:with-param name="parm">     
        <xsl:element name="expr">
            <xsl:attribute name="type">
                <xsl:text>lambda</xsl:text>
            </xsl:attribute>
            <xsl:attribute name="name">
                <xsl:value-of select="saxon:nodeSet($parm)/expr/@name"/>
            </xsl:attribute>

            <xsl:call-template name="apply">
            <xsl:with-param name="parm">            
                <xsl:copy-of select="saxon:nodeSet($parm)/expr/expr"/>
            </xsl:with-param>
            </xsl:call-template>
        </xsl:element>
    </xsl:with-param>
    </xsl:call-template>
</xsl:when>

<xsl:otherwise>
    <xsl:choose>

    <xsl:when test="saxon:nodeSet($parm)/expr/expr[1]/@type='lambda'">
        <check ccc="yes"/>
        <xsl:call-template name="ch">
        <xsl:with-param name="parm">
            <var><xsl:value-of select="saxon:nodeSet($parm)/expr/expr[1]/@name"/></var>
            <term><xsl:copy-of select="saxon:nodeSet($parm)/expr/expr[2]"/></term>
            <xsl:copy-of select="saxon:nodeSet($parm)/expr/expr[1]/expr[1]"/>
        </xsl:with-param>
        </xsl:call-template>
    </xsl:when>

    <xsl:otherwise>
        <xsl:call-template name="Check2">
        <xsl:with-param name="parm">
            <expr>
            <xsl:for-each select="saxon:nodeSet($parm)/expr/expr">
                <xsl:call-template name="apply">
                <xsl:with-param name="parm">
                    <xsl:copy-of select="."/>
                </xsl:with-param>
                </xsl:call-template>
            </xsl:for-each>
            </expr>
        </xsl:with-param>
        </xsl:call-template>
    </xsl:otherwise>

    </xsl:choose>

</xsl:otherwise>
</xsl:choose>

</xsl:template>

<!--================================================-->

<xsl:template name="CheckL"> 
<xsl:param name="parm"/>
    <xsl:copy-of select="saxon:nodeSet($parm)/expr/check"/>
    <xsl:element name="expr">
        <xsl:attribute name="type">
            <xsl:text>lambda</xsl:text>
        </xsl:attribute>
        <xsl:attribute name="name">
            <xsl:value-of select="saxon:nodeSet($parm)/expr/@name"/>
        </xsl:attribute>
        <xsl:copy-of select="saxon:nodeSet($parm)/expr/expr"/>
    </xsl:element>
</xsl:template>

<!--=================================================-->

<xsl:template name="Check2"> 
<xsl:param name="parm"/>
    <xsl:choose>
        <xsl:when test="(saxon:nodeSet($parm)/expr/check[1]/@ccc='no')
                    and (saxon:nodeSet($parm)/expr/check[2]/@ccc='no')">
            <check ccc="no"/>
            <expr>
                <xsl:copy-of select="saxon:nodeSet($parm)/expr/expr[1]"/>
                <xsl:copy-of select="saxon:nodeSet($parm)/expr/expr[2]"/>
            </expr>
        </xsl:when>
    
        <xsl:otherwise>
            <xsl:call-template name="apply">
            <xsl:with-param name="parm">
                <expr>
                <xsl:copy-of select="saxon:nodeSet($parm)/expr/expr[1]"/>
                <xsl:copy-of select="saxon:nodeSet($parm)/expr/expr[2]"/>
                </expr>            
            </xsl:with-param>
            </xsl:call-template>
        </xsl:otherwise>
    </xsl:choose>
</xsl:template>

<!--================================================-->

<xsl:template name="prelude"> 
<xsl:param name="eexpr"/>

        <xsl:call-template name="PRtrue">
        <xsl:with-param name="chparm">

        <xsl:call-template name="PRfalse">
        <xsl:with-param name="chparm">

        <xsl:call-template name="PRimpl">
        <xsl:with-param name="chparm">

        <xsl:call-template name="PRnot">
        <xsl:with-param name="chparm">

        <xsl:call-template name="PRor">
        <xsl:with-param name="chparm">

        <xsl:call-template name="PRand">
        <xsl:with-param name="chparm">

        <xsl:call-template name="PRcond">
        <xsl:with-param name="chparm">

        <xsl:call-template name="PRpair">
        <xsl:with-param name="chparm">

        <xsl:call-template name="PRfst">
        <xsl:with-param name="chparm">

        <xsl:call-template name="PRsnd">
        <xsl:with-param name="chparm">

        <xsl:call-template name="PRzero">
        <xsl:with-param name="chparm">

        <xsl:call-template name="PRsucc">
        <xsl:with-param name="chparm">

        <xsl:call-template name="PRone">
        <xsl:with-param name="chparm">

        <xsl:call-template name="PRiszero">
        <xsl:with-param name="chparm">

        <xsl:call-template name="PRadd">
        <xsl:with-param name="chparm">

        <xsl:call-template name="PRmult">
        <xsl:with-param name="chparm">

        <xsl:call-template name="PRzeropair">
        <xsl:with-param name="chparm">

        <xsl:call-template name="PRpred">
        <xsl:with-param name="chparm">

        <xsl:call-template name="PRsub">
        <xsl:with-param name="chparm">

        <xsl:call-template name="PRfix">
        <xsl:with-param name="chparm">

        <xsl:call-template name="PRfactorial">
        <xsl:with-param name="chparm">

        <xsl:copy-of select="saxon:nodeSet($eexpr)/expr"/>

        </xsl:with-param>
        </xsl:call-template>

        </xsl:with-param>
        </xsl:call-template>

        </xsl:with-param>
        </xsl:call-template>

        </xsl:with-param>
        </xsl:call-template>

        </xsl:with-param>
        </xsl:call-template>

        </xsl:with-param>
        </xsl:call-template>

        </xsl:with-param>
        </xsl:call-template>

        </xsl:with-param>
        </xsl:call-template>

        </xsl:with-param>
        </xsl:call-template>


        </xsl:with-param>
        </xsl:call-template>

        </xsl:with-param>
        </xsl:call-template>

        </xsl:with-param>
        </xsl:call-template>

        </xsl:with-param>
        </xsl:call-template>

        </xsl:with-param>
        </xsl:call-template>

        </xsl:with-param>
        </xsl:call-template>

        </xsl:with-param>
        </xsl:call-template>

        </xsl:with-param>
        </xsl:call-template>

        </xsl:with-param>
        </xsl:call-template>

        </xsl:with-param>
        </xsl:call-template>

        </xsl:with-param>
        </xsl:call-template>

        </xsl:with-param>
        </xsl:call-template>
</xsl:template>

<!--============================================-->
<!--    Replacement variable on expression      -->

<xsl:template name="ch"> 
<xsl:param name="parm"/>
<xsl:for-each select="saxon:nodeSet($parm)/expr">

<xsl:choose>

<xsl:when test="./@type='var'">
    <xsl:choose>

    <xsl:when test="./@name=saxon:nodeSet($parm)/var">
        <xsl:copy-of select="saxon:nodeSet($parm)/term/expr"/>
    </xsl:when>

    <xsl:otherwise>
        <xsl:copy-of select="."/>
    </xsl:otherwise>

    </xsl:choose>
</xsl:when>

<xsl:when test="./@type='lambda'">
    <xsl:choose>

    <xsl:when test="./@name=saxon:nodeSet($parm)/var">
        <xsl:copy-of select="."/>
    </xsl:when>

    <xsl:otherwise>
        <xsl:element name="expr">
            <xsl:attribute name="type">
                <xsl:text>lambda</xsl:text>
            </xsl:attribute>
            <xsl:attribute name="name">
                <xsl:value-of select="./@name"/>
            </xsl:attribute>

            <xsl:call-template name="ch">
            <xsl:with-param name="parm">
                <var><xsl:value-of select="saxon:nodeSet($parm)/var"/></var>
                <term><xsl:copy-of select="saxon:nodeSet($parm)/term/expr"/></term>
                <xsl:copy-of select="expr[1]"/>
                <xsl:copy-of select="expr[2]"/>
            </xsl:with-param>
            </xsl:call-template>
        </xsl:element>
    </xsl:otherwise>

    </xsl:choose>
</xsl:when>

<xsl:otherwise>
    <expr>
        <xsl:call-template name="ch">
        <xsl:with-param name="parm">
            <var><xsl:value-of select="saxon:nodeSet($parm)/var"/></var>
            <term><xsl:copy-of select="saxon:nodeSet($parm)/term/expr"/></term>
            <xsl:copy-of select="expr[1]"/>
            <xsl:copy-of select="expr[2]"/>
        </xsl:with-param>
        </xsl:call-template>
    </expr>
</xsl:otherwise>

</xsl:choose>
</xsl:for-each>
</xsl:template>

<!--===========================================-->
<xsl:template name="newline">
<xsl:text>
</xsl:text>
</xsl:template>

<!--===========================================-->
<!--    Print of expression                    -->

<xsl:template name="prout"> 
<xsl:param name="pr"/>
<xsl:choose>
    <xsl:when test="saxon:nodeSet($pr)/expr/@type='var'">
        <xsl:value-of select="saxon:nodeSet($pr)/expr/@name"/>
        <xsl:text> </xsl:text>
    </xsl:when>

    <xsl:when test="saxon:nodeSet($pr)/expr/@type='lambda'">
        <xsl:text>(\</xsl:text>
        <xsl:value-of select="saxon:nodeSet($pr)/expr/@name"/>
        <xsl:text>. </xsl:text>
        <xsl:call-template name="prout">
        <xsl:with-param name="pr">
            <xsl:copy-of select="saxon:nodeSet($pr)/expr/expr[1]"/>
        </xsl:with-param>
        </xsl:call-template>
        <xsl:text>)</xsl:text>
    </xsl:when>

    <xsl:otherwise>
        <xsl:text>(</xsl:text>
        <xsl:call-template name="prout">
        <xsl:with-param name="pr">
            <xsl:copy-of select="saxon:nodeSet($pr)/expr/expr[1]"/>
        </xsl:with-param>
        </xsl:call-template>
        <xsl:call-template name="prout">
        <xsl:with-param name="pr">
            <xsl:copy-of select="saxon:nodeSet($pr)/expr/expr[2]"/>
        </xsl:with-param>
        </xsl:call-template>
        <xsl:text>)</xsl:text>
    </xsl:otherwise>
</xsl:choose>
</xsl:template>

<!-- ================================================ -->

<!--let true  = (\x. (\y. x ))-->

<xsl:template name="PRtrue">
<xsl:param name="chparm"/>
    <xsl:call-template name="ch">
    <xsl:with-param name="parm">
    <var>true</var>
    <term>
        <expr type="lambda" name="x">
          <expr type="lambda" name="y">
            <expr type="var" name="x"/>
          </expr>
        </expr>
    </term>
    <xsl:copy-of select="saxon:nodeSet($chparm)/expr"/>
    </xsl:with-param>
    </xsl:call-template>
</xsl:template>

<!--let false  = (\x. (\y. y ))-->

<xsl:template name="PRfalse">
<xsl:param name="chparm"/>
    <xsl:call-template name="ch">
    <xsl:with-param name="parm">
    <var>false</var>
    <term>
        <expr type="lambda" name="x">
          <expr type="lambda" name="y">
            <expr type="var" name="y"/>
          </expr>
        </expr>
    </term>
    <xsl:copy-of select="saxon:nodeSet($chparm)/expr"/>
    </xsl:with-param>
    </xsl:call-template>
</xsl:template>

<!--let impl  = (\x. (\y. x y true ))-->

<xsl:template name="PRimpl">
<xsl:param name="chparm"/>
    <xsl:call-template name="ch">
    <xsl:with-param name="parm">
    <var>impl</var>
    <term>
        <expr type="lambda" name="x">
          <expr type="lambda" name="y">
            <expr>
              <expr>
                <expr type="var" name="x"/>
                <expr type="var" name="y"/>
              </expr>
              <expr type="var" name="true"/>
            </expr>
          </expr>
        </expr>
    </term>
    <xsl:copy-of select="saxon:nodeSet($chparm)/expr"/>
    </xsl:with-param>
    </xsl:call-template>
</xsl:template>

<!--let not  = (\x. x false true )-->

<xsl:template name="PRnot">
<xsl:param name="chparm"/>
    <xsl:call-template name="ch">
    <xsl:with-param name="parm">
    <var>not</var>
    <term>
        <expr type="lambda" name="x">
          <expr>
            <expr>
              <expr type="var" name="x"/>
              <expr type="var" name="false"/>
            </expr>
            <expr type="var" name="true"/>
          </expr>
        </expr>
    </term>
    <xsl:copy-of select="saxon:nodeSet($chparm)/expr"/>
    </xsl:with-param>
    </xsl:call-template>
</xsl:template>

<!--let or  = (\x. (\y. impl (not x )y ))-->

<xsl:template name="PRor">
<xsl:param name="chparm"/>
    <xsl:call-template name="ch">
    <xsl:with-param name="parm">
    <var>or</var>
    <term>
        <expr type="lambda" name="x">
          <expr type="lambda" name="y">
            <expr>
              <expr>
                <expr type="var" name="impl"/>
                <expr>
                  <expr type="var" name="not"/>
                  <expr type="var" name="x"/>
                </expr>
              </expr>
              <expr type="var" name="y"/>
            </expr>
          </expr>
        </expr>
    </term>
    <xsl:copy-of select="saxon:nodeSet($chparm)/expr"/>
    </xsl:with-param>
    </xsl:call-template>
</xsl:template>

<!--let and  = (\x. (\y. not (or (not x )(not y ))))-->

<xsl:template name="PRand">
<xsl:param name="chparm"/>
    <xsl:call-template name="ch">
    <xsl:with-param name="parm">
    <var>and</var>
    <term>
        <expr type="lambda" name="x">
          <expr type="lambda" name="y">
            <expr>
              <expr type="var" name="not"/>
              <expr>
                <expr>
                  <expr type="var" name="or"/>
                  <expr>
                    <expr type="var" name="not"/>
                    <expr type="var" name="x"/>
                  </expr>
                </expr>
                <expr>
                  <expr type="var" name="not"/>
                  <expr type="var" name="y"/>
                </expr>
              </expr>
            </expr>
          </expr>
        </expr>
    </term>
    <xsl:copy-of select="saxon:nodeSet($chparm)/expr"/>
    </xsl:with-param>
    </xsl:call-template>
</xsl:template>

<!--let cond  = (\b. b )-->

<xsl:template name="PRcond">
<xsl:param name="chparm"/>
    <xsl:call-template name="ch">
    <xsl:with-param name="parm">
    <var>cond</var>
    <term>
        <expr type="lambda" name="b">
          <expr type="var" name="b"/>
        </expr>
    </term>
    <xsl:copy-of select="saxon:nodeSet($chparm)/expr"/>
    </xsl:with-param>
    </xsl:call-template>
</xsl:template>

<!--let pair  = (\x. (\y. (\z. z x y )))-->

<xsl:template name="PRpair">
<xsl:param name="chparm"/>
    <xsl:call-template name="ch">
    <xsl:with-param name="parm">
    <var>pair</var>
    <term>
        <expr type="lambda" name="x">
          <expr type="lambda" name="y">
            <expr type="lambda" name="z">
              <expr>
                <expr>
                  <expr type="var" name="z"/>
                  <expr type="var" name="x"/>
                </expr>
                <expr type="var" name="y"/>
              </expr>
            </expr>
          </expr>
        </expr>
    </term>
    <xsl:copy-of select="saxon:nodeSet($chparm)/expr"/>
    </xsl:with-param>
    </xsl:call-template>
</xsl:template>

<!--let fst  = (\n. n true )-->

<xsl:template name="PRfst">
<xsl:param name="chparm"/>
    <xsl:call-template name="ch">
    <xsl:with-param name="parm">
    <var>fst</var>
    <term>
        <expr type="lambda" name="n">
          <expr>
            <expr type="var" name="n"/>
            <expr type="var" name="true"/>
          </expr>
        </expr>
    </term>
    <xsl:copy-of select="saxon:nodeSet($chparm)/expr"/>
    </xsl:with-param>
    </xsl:call-template>
</xsl:template>

<!--let snd  = (\n. n false )-->

<xsl:template name="PRsnd">
<xsl:param name="chparm"/>
    <xsl:call-template name="ch">
    <xsl:with-param name="parm">
    <var>snd</var>
    <term>
        <expr type="lambda" name="n">
          <expr>
            <expr type="var" name="n"/>
            <expr type="var" name="false"/>
          </expr>
        </expr>
    </term>
    <xsl:copy-of select="saxon:nodeSet($chparm)/expr"/>
    </xsl:with-param>
    </xsl:call-template>
</xsl:template>

<!--let zero  = (\s. (\z. z ))-->

<xsl:template name="PRzero">
<xsl:param name="chparm"/>
    <xsl:call-template name="ch">
    <xsl:with-param name="parm">
    <var>zero</var>
    <term>
        <expr type="lambda" name="s">
          <expr type="lambda" name="z">
            <expr type="var" name="z"/>
          </expr>
        </expr>
    </term>
    <xsl:copy-of select="saxon:nodeSet($chparm)/expr"/>
    </xsl:with-param>
    </xsl:call-template>
</xsl:template>

<!--let succ  = (\n. (\s. (\z. s (n s z ))))-->

<xsl:template name="PRsucc">
<xsl:param name="chparm"/>
    <xsl:call-template name="ch">
    <xsl:with-param name="parm">
    <var>succ</var>
    <term>
        <expr type="lambda" name="n">
          <expr type="lambda" name="s">
            <expr type="lambda" name="z">
              <expr>
                <expr type="var" name="s"/>
                <expr>
                  <expr>
                    <expr type="var" name="n"/>
                    <expr type="var" name="s"/>
                  </expr>
                  <expr type="var" name="z"/>
                </expr>
              </expr>
            </expr>
          </expr>
        </expr>
    </term>
    <xsl:copy-of select="saxon:nodeSet($chparm)/expr"/>
    </xsl:with-param>
    </xsl:call-template>
</xsl:template>

<!--let one  = (succ zero )-->

<xsl:template name="PRone">
<xsl:param name="chparm"/>
    <xsl:call-template name="ch">
    <xsl:with-param name="parm">
    <var>one</var>
    <term>
        <expr>
          <expr type="var" name="succ"/>
          <expr type="var" name="zero"/>
        </expr>
    </term>
    <xsl:copy-of select="saxon:nodeSet($chparm)/expr"/>
    </xsl:with-param>
    </xsl:call-template>
</xsl:template>

<!--let iszero  = (\n. n (\x. false )true )-->

<xsl:template name="PRiszero">
<xsl:param name="chparm"/>
    <xsl:call-template name="ch">
    <xsl:with-param name="parm">
    <var>iszero</var>
    <term>
        <expr type="lambda" name="n">
          <expr>
            <expr>
              <expr type="var" name="n"/>
              <expr type="lambda" name="x">
                <expr type="var" name="false"/>
              </expr>
            </expr>
            <expr type="var" name="true"/>
          </expr>
        </expr>
    </term>
    <xsl:copy-of select="saxon:nodeSet($chparm)/expr"/>
    </xsl:with-param>
    </xsl:call-template>
</xsl:template>

<!--let add  = (\n. (\m. n succ m ))-->

<xsl:template name="PRadd">
<xsl:param name="chparm"/>
    <xsl:call-template name="ch">
    <xsl:with-param name="parm">
    <var>add</var>
    <term>
        <expr type="lambda" name="n">
          <expr type="lambda" name="m">
            <expr>
              <expr>
                <expr type="var" name="n"/>
                <expr type="var" name="succ"/>
              </expr>
              <expr type="var" name="m"/>
            </expr>
          </expr>
        </expr>
    </term>
    <xsl:copy-of select="saxon:nodeSet($chparm)/expr"/>
    </xsl:with-param>
    </xsl:call-template>
</xsl:template>

<!--let mult  = (\n. (\m. n (add m )zero ))-->

<xsl:template name="PRmult">
<xsl:param name="chparm"/>
    <xsl:call-template name="ch">
    <xsl:with-param name="parm">
    <var>mult</var>
    <term>
        <expr type="lambda" name="n">
          <expr type="lambda" name="m">
            <expr>
              <expr>
                <expr type="var" name="n"/>
                <expr>
                  <expr type="var" name="add"/>
                  <expr type="var" name="m"/>
                </expr>
              </expr>
              <expr type="var" name="zero"/>
            </expr>
          </expr>
        </expr>
    </term>
    <xsl:copy-of select="saxon:nodeSet($chparm)/expr"/>
    </xsl:with-param>
    </xsl:call-template>
</xsl:template>

<!--let zeropair  = (pair zero zero )-->

<xsl:template name="PRzeropair">
<xsl:param name="chparm"/>
    <xsl:call-template name="ch">
    <xsl:with-param name="parm">
    <var>zeropair</var>
    <term>
        <expr>
          <expr>
            <expr type="var" name="pair"/>
            <expr type="var" name="zero"/>
          </expr>
          <expr type="var" name="zero"/>
        </expr>
    </term>
    <xsl:copy-of select="saxon:nodeSet($chparm)/expr"/>
    </xsl:with-param>
    </xsl:call-template>
</xsl:template>

<!--let pred  = (\n. snd (n (\x. (pair (succ (fst x ))(fst x )))zeropair ))-->

<xsl:template name="PRpred">
<xsl:param name="chparm"/>
    <xsl:call-template name="ch">
    <xsl:with-param name="parm">
    <var>pred</var>
    <term>
        <expr type="lambda" name="n">
          <expr>
            <expr type="var" name="snd"/>
            <expr>
              <expr>
                <expr type="var" name="n"/>
                <expr type="lambda" name="x">
                  <expr>
                    <expr>
                      <expr type="var" name="pair"/>
                      <expr>
                        <expr type="var" name="succ"/>
                        <expr>
                          <expr type="var" name="fst"/>
                          <expr type="var" name="x"/>
                        </expr>
                      </expr>
                    </expr>
                    <expr>
                      <expr type="var" name="fst"/>
                      <expr type="var" name="x"/>
                    </expr>
                  </expr>
                </expr>
              </expr>
              <expr type="var" name="zeropair"/>
            </expr>
          </expr>
        </expr>
    </term>
    <xsl:copy-of select="saxon:nodeSet($chparm)/expr"/>
    </xsl:with-param>
    </xsl:call-template>
</xsl:template>

<!--let sub  = (\n. (\m. (m pred n )))-->

<xsl:template name="PRsub">
<xsl:param name="chparm"/>
    <xsl:call-template name="ch">
    <xsl:with-param name="parm">
    <var>sub</var>
    <term>
        <expr type="lambda" name="n">
          <expr type="lambda" name="m">
            <expr>
              <expr>
                <expr type="var" name="m"/>
                <expr type="var" name="pred"/>
              </expr>
              <expr type="var" name="n"/>
            </expr>
          </expr>
        </expr>
    </term>
    <xsl:copy-of select="saxon:nodeSet($chparm)/expr"/>
    </xsl:with-param>
    </xsl:call-template>
</xsl:template>

<!--let fix  = (\f. (\x. f (x x ))(\x. f (x x )))-->

<xsl:template name="PRfix">
<xsl:param name="chparm"/>
    <xsl:call-template name="ch">
    <xsl:with-param name="parm">
    <var>fix</var>
    <term>
        <expr type="lambda" name="f">
          <expr>
            <expr type="lambda" name="x">
              <expr>
                <expr type="var" name="f"/>
                <expr>
                  <expr type="var" name="x"/>
                  <expr type="var" name="x"/>
                </expr>
              </expr>
            </expr>
            <expr type="lambda" name="x">
              <expr>
                <expr type="var" name="f"/>
                <expr>
                  <expr type="var" name="x"/>
                  <expr type="var" name="x"/>
                </expr>
              </expr>
            </expr>
          </expr>
        </expr>
    </term>
    <xsl:copy-of select="saxon:nodeSet($chparm)/expr"/>
    </xsl:with-param>
    </xsl:call-template>
</xsl:template>

<!--let factorial  = (fix (\f. (\n. cond (iszero n )one (mult n (f (pred n ))))))-->

<xsl:template name="PRfactorial">
<xsl:param name="chparm"/>
    <xsl:call-template name="ch">
    <xsl:with-param name="parm">
    <var>factorial</var>
    <term>
        <expr>
          <expr type="var" name="fix"/>
          <expr type="lambda" name="f">
            <expr type="lambda" name="n">
              <expr>
                <expr>
                  <expr>
                    <expr type="var" name="cond"/>
                    <expr>
                      <expr type="var" name="iszero"/>
                      <expr type="var" name="n"/>
                    </expr>
                  </expr>
                  <expr type="var" name="one"/>
                </expr>
                <expr>
                  <expr>
                    <expr type="var" name="mult"/>
                    <expr type="var" name="n"/>
                  </expr>
                  <expr>
                    <expr type="var" name="f"/>
                    <expr>
                      <expr type="var" name="pred"/>
                      <expr type="var" name="n"/>
                    </expr>
                  </expr>
                </expr>
              </expr>
            </expr>
          </expr>
        </expr>
    </term>
    <xsl:copy-of select="saxon:nodeSet($chparm)/expr"/>
    </xsl:with-param>
    </xsl:call-template>
</xsl:template>

</xsl:stylesheet>

<!-- ========== end ========== end ========== -->